\section{Transport Layer Security}
Secure Socket Layer (SSL) and Transport Layer Security (TLS) are network security protocols for setting up authenticated and encrypted connections and exchanging data. Secure Socket Layer (SSL) was the original name, which became after version 3.0 Transport Layer Security (TLS),  which currently exists as version 1.3. People still use SSL as a term, even though technically it is now TLS. \textbf{TLS is the primary mechanism for encryption for HTTP communication, that is called HTTPS.} TLS could be provided as part of the underlying  protocol suite and therefore be transparent to applications.


\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{tlsstack}
  \caption{TLS Stack}
\end{figure}

We can talk about the OSI layer 4+ and that's exactly where TLS is acting. TLS relies on TCP. 

\begin{figure}[h!]
  \center
  \includegraphics[width=0.5\textwidth]{tlsprotocollayer}
  \caption{TLS Protocol Layer}
\end{figure}

\subsection{Connections and Sessions}
\begin{description}
	\item[Connection] \hfill \\
	Is a transport that provides a suitable type of service.  Such connections are peer-to-peer relationships. Connections are transient (dt.: flüchtig). Every connection is associated with one session.\\
	\includegraphics[width=0.75\linewidth]{connectionstate}
	\item[Session] \hfill \\
	Is an association between a client and a server created by the Handshake Protocol. Defines a set of cryptographic security parameters which can be shared among multiple connections.  Sessions are used to avoid the expensive negotiation of new security parameters for each connection. 
	\includegraphics[width=0.5\linewidth]{sessionstate}
\end{description}

\subsection{TLS History}
TLS 1.3 (RFC 8446) has the following key improvements. 

\begin{description}
	\item[Clean up - Remove unsafe features] \hfill \\
	Remove legacy and broken crypto: (3)DES, RC4, MD5, SHA1, Kerberos, RSA PKCS\#1v1.5. key transport. Remove broken features: compression and renegotiation. Remove static RSA/DH (breaks enterprise proxies doing passive inspection). TLS 1.3 makes it impossible to read the data packets, therefore the adoption is really slow.
	\item[Performance] \hfill \\
	Added 1-RTT and 0-RTT handshakes 
	\item[Security] \hfill \\
	Improve security with modern techniques.
	\item[Privacy] \hfill \\
	Encrypt more of the protocol, i.e. encrypt almost all handshake messages.
\end{description}

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{tlshistory}
  \caption{History of TLS}
\end{figure}

\subsection{TLS Record Structure}
The record header has different values.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{tlsrecordstructure}
  \caption{TLS Record Strucutre}
\end{figure}

We have different Content types for different applications of the protocol.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{tlscontenttypes}
  \caption{TLS Record Types}
\end{figure}

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{tlsrecord}
  \caption{TLS Record}
\end{figure}

\subsection{TLS Handshake}
The Handshake is the most complex part of TLS. It's used before any application data is transmitted. It comprises a series of messages exchanged by client and server.

\begin{figure}[h!]
  \center
  \includegraphics[width=\textwidth]{tlshandshake}
  \caption{TLS Handshake}
\end{figure}

\subsection{TLS Handshake Protocol}

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{tlshandshakeprotocol}
  \caption{TLS Handshake Protocol}
\end{figure}

\subsubsection{RSA Public Key Encryption}
No perfect forward secrecy! \\

\begin{figure}[h!]
  \center
  \includegraphics[width=\textwidth]{tlsrsa}
  \caption{TLS with RSA}
\end{figure}

\subsubsection{DFH Public Key Encryption}
Does support perfect forward secrecy. The premaster secret gets calculated from every participant and is never send over a secure or insecure channel.

\includegraphics[width=0.75\linewidth]{tlsdh}
\subsubsection{Computing the TLS Master Secret}
\includegraphics[width=0.75\linewidth]{tlsmastersecret} 
\subsubsection{HMAC based Pseudo Random Function}
\includegraphics[width=0.75\linewidth]{tlshmac} 
\subsubsection{Authenticated Encryption}
There are different usages of TLS for different tasks. 

\includegraphics[width=0.75\linewidth]{tlsaenc} 
\subsubsection{TLS Cipher Suites}
The different colours state what is specified where in the TLS suite name. 

\includegraphics[width=0.75\linewidth]{tlsciphersuites} 
\subsubsection{Alert Protocol}
\includegraphics[width=0.75\linewidth]{tlsalert} 

\subsubsection{TLS Session Resumption}
\includegraphics[width=0.75\linewidth]{tlsresume} 

\subsubsection{Heartbeat Protocol}
A periodic signal generated by hardware or software to indicate normal operation or to synchronize other parts of a system. Typically used to monitor the availability of a protocol entity. Runs on top of the TLS Record Protocol.

\subsubsection{SSL/TLS Attacks}
The Hearbleed buffer overflow attack is baed on a bug where the servers puts data from the buffer in the answer and the attacker has information that he shouldn't have. \\
\includegraphics[width=0.75\linewidth]{tlsattacks} 

\subsection{TLS 1.3}
The Handshake in TLS 1.3 needs only a one rund trip handshake (1-RTT). Less is more an we are finished with the handshake in under 200ms.

\includegraphics[width=0.75\linewidth]{tls1rtt}
 
\subsubsection{TLS 1.3 Cipher Suites}
TLS has reduced the cipher suites from over 100 to just 5 cipher suites. 

\includegraphics[width=0.75\linewidth]{tls13cipher} 
